/*! \file bistree.h
 *
 * \brief Fichier en-tête pour les arbres binaires de recherche
 *
 * Ce fichier regroupe tous les fichiers en-tête pour les versions spécialisées
 * des arbres binaires de recherche (contenant des entiers, des flottants ou des
 * caractères) ainsi que la version générique des arbres binaires de recherche.
 *
 */

/*****************************************************************************
*                                                                            *
*  -------------------------------- bistree.h -----------------------------  *
*                                                                            *
*****************************************************************************/

#ifndef __BINARY_SEARCH_TREE_H__
#define __BINARY_SEARCH_TREE_H__

#include "integer_bistree.h"
#include "real_bistree.h"
#include "character_bistree.h"
#include "generic_bistree.h"

#endif
