/*! \file bitree.h
 *
 * \brief Fichier en-tête pour les arbres binaires
 *
 * Ce fichier regroupe tous les fichiers en-tête pour les versions spécialisées
 * des arbres binaires (contenant des entiers, des flottants ou des
 * caractères) ainsi que la version générique des arbres binaires.
 *
 */


/*****************************************************************************
*                                                                            *
*  -------------------------------- bitree.h ------------------------------  *
*                                                                            *
*****************************************************************************/

#ifndef __BINARY_TREE_H__
#define __BINARY_TREE_H__

#include "integer_bitree.h"
#include "real_bitree.h"
#include "character_bitree.h"
#include "generic_bitree.h"

#endif
