/*! \file bitreealg.h
 *
 * \brief Fichier en-tête pour les algorithmes agissant sur les arbres binaires
 *
 * Ce fichier regroupe tous les fichiers en-tête pour les versions
 * spécialisées des algorithmes agissant sur arbres binaires
 * (contenant des entiers, des flottants ou des caractères) ainsi que
 * pour la version générique des arbres binaires.
 *
 * <b>Ces algorithmes fonctionnent également sur les structures
 * d'arbres binaires de recherches</b>
 *
 */

/*****************************************************************************
*                                                                            *
*  -------------------------------- bitree.h ------------------------------  *
*                                                                            *
*****************************************************************************/

#ifndef __BINARY_TREE_ALG_H__
#define __BINARY_TREE_ALG_H__

#include "integer_bitreealg.h"
#include "real_bitreealg.h"
#include "character_bitreealg.h"
#include "generic_bitreealg.h"

#endif
