/*! \file libin103.h
 *
 * \brief Fichier en-tête pour toute la bibliothèque libin103
 *
 * Ce fichier regroupe tous les fichiers en-tête pour les structures
 * de données étudiées en cours
 *
 */

/*****************************************************************************
*                                                                            *
*  ------------------------------- libin103.h -----------------------------  *
*                                                                            *
*****************************************************************************/


#ifndef LIBIN103_H
#define LIBIN103_H

#include "list.h"
#include "stack.h"
#include "queue.h"
#include "set.h"
#include "bitree.h"
#include "bitreealg.h"
#include "bistree.h"
#include "heap.h"
#include "uf.h"
#include "graph.h"
#include "graphalg.h"

#endif

/*! \mainpage Documentation de la bibliothèque libin103
 *
 * \section intro_sec Introduction
 *
 * Ces quelques pages HTML regroupent l'ensemble de la documentation
 * de la bibliothèque libin103 qui donne accès à des strctures de
 * données en langage C. On peut y trouver une documentation des types
 * de données utilisées pour mettre en oeuvre les strctures de données
 * ainsi que la description des interfaces de programmation de ces
 * structures de données.
 *
 * La bibiliothèque libin103 s'appuie sur la mise en oeuvre des
 * strucrures de données en langage C décrite dans le livre "Mastering
 * Algorithms with C" de Kyle Loudon chez O’Reilly, 1999.
 *
 * \section lib_sec Accès à la bibliothèque libin103
 *
 * Le <b><a
 * href="https://perso.ensta-paris.fr/~chapoutot/teaching/in103/">site
 * web du cours IN103</a></b> pour télécharger la bibiliothèque libin103
 * dans sa dernière version.
 *
 */
